/*
 *
 * This file is to test the correlating NAG facilities....
 * Using G13DMF
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <malloc.h>
#include "/usr/local/numerics/recipes_c-kr/misc/nrutil.h"
#include "/usr/local/numerics/recipes_c-kr/misc/nrutil.c"


extern void g13dmf();   

char progid[100];

int main(argc,argv)
int argc;
char **argv;
{
 
  int k;                              /* Number of observed time series */
  int nx;                             /* Number of observations */
  int ns;                             /* Number of series */
  int nl;                             /* Maximum Lag considered */
  int icr;                            /* icr = 0 --> Cross Covariances Supported icr= 1--> Cross Correlations*/
  double *x;                          /* Holds the n observations of the k time series */
  double *m;                          /* Holds the means */
  double *c0;                         /* Zero Lag Cross-Correlations */
  double *c;                          /* Lagged Correlations */
  int ifail;
  FILE *fp;
  char buff[82],ctyp;
  register int i,j;

  strcpy(progid,argv[0]);

  if(argc!=6){
    fprintf(stderr,"usage: %s data_file #times #series #lags icr=[0,1]\n",progid);
    exit(-1);
  }


   if((fp=fopen(argv[1],"r"))==NULL){
     fprintf(stderr,"%s: unable to open datafile %s\n",progid,argv[1]);
     exit(-1);
   }

  nx= atoi(argv[2]);
  ns= atoi(argv[3]);
  nl= atoi(argv[4]);
  icr= atoi(argv[5]);

  fprintf(stdout,"%s output of data-file %s\n",argv[0],argv[1]);
  fprintf(stdout,"%d %d %d\n",nx,ns,nl);

  x=     (double *) dvector(0,ns*nx-1);
  c0=    (double *) dvector(0,ns*ns-1);
  c=     (double *) dvector(0,ns*ns*nl-1);
  m=     (double *) dvector(0,ns-1);

  for(i=0; i<nx; i++){
    fscanf(fp,"%*f");
    for(j=0; j<ns; j++)
      fscanf(fp,"%lf",&x[i*ns+j]);
    }

  fclose(fp);

  if(icr==0) ctyp= 'V';
  else ctyp= 'R';

  ifail=0;

  g13dmf(&ctyp,&ns,&nx,&nl,x,&ns,m,c0,c,&ifail);

  fprintf(stdout,"\nifail= %d : Cross %s\nLag 0\n\n",ifail,(icr==0 ? "Covariances":"Correlations"));

  for(j=0; j<ns; j++){
    for(i=0; i<ns; i++){
      if(icr==1 && i==j) c0[j*ns+i]= 1.0;
      fprintf(stdout,"%.6e\t",c0[j*ns+i]);
    }
    fprintf(stdout,"\n");
  }

  for(i=0; i<nl; i++){
    fprintf(stdout,"\nLag %d\n",i+1);
    for(j=0; j<ns; j++){
      for(k=0; k<ns; k++)
	fprintf(stdout,"%.6e\t",c[i*ns*ns + j*ns +k]);
      fprintf(stdout,"\n");
    }
  }
     
  exit(0);
}










