/*
 *
 * File to make gnuplot data from correlation files.
 * Prints Correlation surface between i and all series (lagging and leading j vs. lag
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <malloc.h>
#include "/usr/local/numerics/recipes_c-kr/misc/nrutil.h"
#include "/usr/local/numerics/recipes_c-kr/misc/nrutil.c"

char progid[100];

int main(argc,argv)
int argc;
char **argv;
{

  FILE *fp;
  int i,j,k,l,ns,nx,nl;
  double **srf;
  double **tmat;
  char buff[100];

  if(argc!=3){
    fprintf(stderr,"usage: %s data_file series1\n",argv[0]);
    exit(-1);
  }

  strcpy(progid,argv[0]);

  i= atoi(argv[2])-1;
 

  if((fp=fopen(argv[1],"r"))==NULL){
    fprintf(stderr,"%s: Unable to open correlation file %s\n",progid,argv[1]);
    exit(-1);
  }

  fgets(buff,81,fp);
  fscanf(fp,"%d %d %d",&nx ,&ns,&nl);

  srf= (double **) dmatrix(0,nl,0,2*ns-1,0);
  tmat= (double **) dmatrix(0,ns-1,0,ns-1);

  for(k=0; k<=nl; k++){
      do{

	if(fscanf(fp,"%s",buff)==EOF){
	  if(k==0)
	    fprintf(stderr,"%s: This file does not seem to contain any lag matrices\n",progid);
	  else
	    fprintf(stderr,"%s: This file is truncated at %d when %d lags were specified.\n",progid,k,nl);
	  exit(-1);
	}
      }while(strcmp(buff,"Lag")!=0);

      fscanf(fp,"%*s"); /* Get Rid of Lag # */

      /* Read in Matrix */

      for(j=0; j<ns; j++)
	for(l=0; l<ns; l++){
	  fscanf(fp,"%lf",&tmat[j][l]);
	}
      /* Transfer proper matrix entries into surface matrix */

      for(j=0; j<ns; j++){
	srf[k][ns+j]= tmat[i][j];
	srf[k][ns-1-j]   = tmat[j][i];
     }    
 
    }

  for(j=0; j<ns; j++){
    for(k=0; k<nl; k++)
     fprintf(stdout,"%.6e %.6e %.6e\n",(double) j,(double) -nl+1+k,srf[nl-1-k][ns-1-j]);
    for(k=1; k<nl; k++)
      fprintf(stdout,"%.6e %.6e %.6e\n",(double) j,(double) k,srf[k][ns+j]);
    fprintf(stdout,"\n");
  }

/*
  for(k=0; k<nl; k++){
    for(j= 0; j< 2*ns; j++)
      fprintf(stdout,"%.6e %.6e %.6e\n",(double) k,(double) -ns+1+j,srf[k][j]);
    fprintf(stdout,"\n");
  }
*/      
  exit(0);
}





