/*
 *
 * This file is to test the varma NAG facilities....
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <malloc.h>
#include "/usr/local/numerics/recipes_c-kr/misc/nrutil.h"
#include "/usr/local/numerics/recipes_c-kr/misc/nrutil.c"

char progid[100];

int main(argc,argv)
int argc;
char **argv;
{
 
  int k;                             /* Number of observed time series */
  int n;                             /* Number of observations */
  int ip;                            /* Number of Autoregressive parameter matrices */
  int mean;
  int ik;                            /* I think this is the same as k? */
  double *w,*avg,*dev;                        /* Holds the n observation of the k time series */
  FILE *fp;
  char buff[82];
  register int i,j;
  double min,max;
  char task;

  strcpy(progid,argv[0]);

  if(argc!=5){
    fprintf(stderr,"usage: %s data_file #species #timepts task\n",progid);
    fprintf(stderr,"task=:\td- difference\n");
    fprintf(stderr,"task=:\tu- rescale between zero and one\n");
    fprintf(stderr,"task=:\tn- rescale by the average fluctuation\n");
    fprintf(stderr,"task=:\tb- u and d\n");
    fprintf(stderr,"task=:\tm- n and d\n");
    exit(-1);
  }


   if((fp=fopen(argv[1],"r"))==NULL){
     fprintf(stderr,"%s: unable to open datafile dummydata\n",progid);
     exit(-1);
   }

  ik=k=atoi(argv[2]);
  n= atoi(argv[3]);
  task= argv[4][0];

  w= (double *) dvector(0,ik*n-1);
  if(task=='n' || task=='m'){
    avg= (double *) dvector(0,ik*n-1);
    dev= (double *) dvector(0,ik*n-1);
  }

  for(j=0; j<n; j++){
    fscanf(fp,"%*f"); /* skip time column */
    for(i=0; i<k; i++)
      fscanf(fp,"%lf",&w[j*k+i]);
  }
  
  fclose(fp);

if(task=='d' || task== 'b' || task == 'm'){
  for(i=0; i<k; i++)
    for(j=1; j<n; j++) w[(j-1)*k+i] = w[j*k+i]-w[(j-1)*k+i];
  n--;
}

if(task== 'n' || task=='m'){
  for(i=0; i<k; i++){
    avg[i]=0.0;
    for(j=0; j<n; j++) avg[i]+= w[j*k+i];
    avg[i] /= n;
    dev[i]=0.0;
    for(j=0; j<n; j++) dev[i]+= fabs(w[j*k+i]-avg[i]);
    dev[i] /= n;
  }
}

if(task!='d'){
  for(i=0; i<k; i++){
    if(task== 'u' || task=='b'){
      min=1e12; max= -1e12;
      for(j=0; j<n; j++){
	if(w[j*k+i]>max) max=w[j*k+i];
	if(w[j*k+i]<min) min=w[j*k+i];
      }
      for(j=0; j<n; j++) w[j*k+i]= (w[j*k+i]-min)/(max-min);
    } else {
      for(j=0; j<n; j++) w[j*k+i] = (w[j*k+i]-avg[i])/(dev[i]== 0 ? 1.0 : dev[i]);
    }
  }
}

 
   for(j=1; j<n; j++){
    fprintf(stdout,"%e\t",(double) j);
    for(i=0; i<k; i++)
      fprintf(stdout,"%.10e\t",w[j*k+i]);
    fprintf(stdout,"\n");
  }

  fflush(stdout);

 exit(0);
}



